﻿namespace Windows.UI.Xaml
{
	/// <summary>
	/// Describes how a child element is vertically positioned or stretched within a parent's layout slot.
	/// </summary>
	public enum VerticalAlignment
	{
		/// <summary>
		/// The element is aligned to the top of the parent's layout slot.
		/// </summary>
		Top,
		/// <summary>
		/// The element is aligned to the center of the parent's layout slot.
		/// </summary>
		Center,
		/// <summary>
		/// The element is aligned to the bottom of the parent's layout slot.
		/// </summary>
		Bottom,
		/// <summary>
		/// The element is stretched to fill the entire layout slot of the parent element.
		/// </summary>
		Stretch,
	}
}

